diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/test.py ns-3.41/test.py
--- ns-3.40/test.py	2023-09-27 13:30:37.934840000 -0700
+++ ns-3.41/test.py	2024-02-09 14:44:08.629795300 -0800
@@ -1110,7 +1170,7 @@
     # match what is done in the CMakeLists.txt file.
     #
     test_runner_name = "%s%s-%s%s" % (APPNAME, VERSION, "test-runner", BUILD_PROFILE_SUFFIX)
-    test_runner_name += '.exe' if sys.platform == 'win32' else ''
+    test_runner_name += ".exe" if sys.platform == "win32" else ""
 
     #
     # Run ns3 to make sure that everything is built, configured and ready to go
@@ -1119,7 +1179,6 @@
     # we allow users that know what they're doing to not invoke ns3 at all.
     #
     if not args.no_build:
-
         # If the user only wants to run a single example, then we can just build
         # that example.
         #
@@ -1142,7 +1201,6 @@
             print("ns3 died. Not running tests", file=sys.stderr)
             return proc.returncode
 
-
     #
     # Dynamically set up paths.
     #
@@ -1157,7 +1215,10 @@
         ns3_runnable_scripts = get_list_from_file(lock_filename, "ns3_runnable_scripts")
         ns3_runnable_scripts = [os.path.basename(script) for script in ns3_runnable_scripts]
     else:
-        print('The build status file was not found.  You must configure before running test.py.', file=sys.stderr)
+        print(
+            "The build status file was not found.  You must configure before running test.py.",
+            file=sys.stderr,
+        )
         sys.exit(2)
 
     #
@@ -1177,10 +1238,10 @@
     python_tests = []
     for directory in EXAMPLE_DIRECTORIES:
         # Set the directories and paths for this example.
-        example_directory   = os.path.join("examples", directory)
+        example_directory = os.path.join("examples", directory)
         examples_to_run_path = os.path.join(example_directory, "examples-to-run.py")
-        cpp_executable_dir   = os.path.join(NS3_BUILDDIR, example_directory)
-        python_script_dir    = os.path.join(example_directory)
+        cpp_executable_dir = os.path.join(NS3_BUILDDIR, example_directory)
+        python_script_dir = os.path.join(example_directory)
 
         # Parse this example directory's file.
         parse_examples_to_run_file(
@@ -1189,18 +1250,19 @@
             python_script_dir,
             example_tests,
             example_names_original,
-            python_tests)
+            python_tests,
+        )
 
     for module in NS3_ENABLED_MODULES:
         # Remove the "ns3-" from the module name.
-        module = module[len("ns3-"):]
+        module = module[len("ns3-") :]
 
         # Set the directories and paths for this example.
-        module_directory     = os.path.join("src", module)
-        example_directory    = os.path.join(module_directory, "examples")
+        module_directory = os.path.join("src", module)
+        example_directory = os.path.join(module_directory, "examples")
         examples_to_run_path = os.path.join(module_directory, "test", "examples-to-run.py")
-        cpp_executable_dir   = os.path.join(NS3_BUILDDIR, example_directory)
-        python_script_dir    = os.path.join(example_directory)
+        cpp_executable_dir = os.path.join(NS3_BUILDDIR, example_directory)
+        python_script_dir = os.path.join(example_directory)
 
         # Parse this module's file.
         parse_examples_to_run_file(
@@ -1209,18 +1271,19 @@
             python_script_dir,
             example_tests,
             example_names_original,
-            python_tests)
+            python_tests,
+        )
 
     for module in NS3_ENABLED_CONTRIBUTED_MODULES:
         # Remove the "ns3-" from the module name.
-        module = module[len("ns3-"):]
+        module = module[len("ns3-") :]
 
         # Set the directories and paths for this example.
-        module_directory     = os.path.join("contrib", module)
-        example_directory    = os.path.join(module_directory, "examples")
+        module_directory = os.path.join("contrib", module)
+        example_directory = os.path.join(module_directory, "examples")
         examples_to_run_path = os.path.join(module_directory, "test", "examples-to-run.py")
-        cpp_executable_dir   = os.path.join(NS3_BUILDDIR, example_directory)
-        python_script_dir    = os.path.join(example_directory)
+        cpp_executable_dir = os.path.join(NS3_BUILDDIR, example_directory)
+        python_script_dir = os.path.join(example_directory)
 
         # Parse this module's file.
         parse_examples_to_run_file(
@@ -1229,7 +1292,8 @@
             python_script_dir,
             example_tests,
             example_names_original,
-            python_tests)
+            python_tests,
+        )
 
     #
     # If lots of logging is enabled, we can crash Python when it tries to
@@ -1246,25 +1310,41 @@
     #
     if args.kinds:
         path_cmd = os.path.join("utils", test_runner_name + " --print-test-type-list")
-        (rc, standard_out, standard_err, et) = run_job_synchronously(path_cmd, os.getcwd(), False, False)
+        (rc, standard_out, standard_err, et) = run_job_synchronously(
+            path_cmd, os.getcwd(), False, False
+        )
         print(standard_out)
 
     if args.list:
         list_items = []
         if ENABLE_TESTS:
             if len(args.constrain):
-                path_cmd = os.path.join("utils", test_runner_name + " --print-test-name-list --print-test-types --test-type=%s" % args.constrain)
+                path_cmd = os.path.join(
+                    "utils",
+                    test_runner_name
+                    + " --print-test-name-list --print-test-types --test-type=%s" % args.constrain,
+                )
             else:
-                path_cmd = os.path.join("utils", test_runner_name + " --print-test-name-list --print-test-types")
-            (rc, standard_out, standard_err, et) = run_job_synchronously(path_cmd, os.getcwd(), False, False)
+                path_cmd = os.path.join(
+                    "utils", test_runner_name + " --print-test-name-list --print-test-types"
+                )
+            (rc, standard_out, standard_err, et) = run_job_synchronously(
+                path_cmd, os.getcwd(), False, False
+            )
             if rc != 0:
                 # This is usually a sign that ns-3 crashed or exited uncleanly
-                print(('test.py error:  test-runner return code returned {}'.format(rc)))
-                print(('To debug, try running {}\n'.format('\'./ns3 run \"test-runner --print-test-name-list\"\'')))
+                print(("test.py error:  test-runner return code returned {}".format(rc)))
+                print(
+                    (
+                        "To debug, try running {}\n".format(
+                            "'./ns3 run \"test-runner --print-test-name-list\"'"
+                        )
+                    )
+                )
                 return
             if isinstance(standard_out, bytes):
                 standard_out = standard_out.decode()
-            list_items = standard_out.split('\n')
+            list_items = standard_out.split("\n")
             list_items.sort()
         print("Test Type    Test Name")
         print("---------    ---------")
@@ -1277,8 +1357,8 @@
             examples_sorted.sort()
         if ENABLE_PYTHON_BINDINGS:
             python_examples_sorted = []
-            for (x, y) in python_tests:
-                if y == 'True':
+            for x, y in python_tests:
+                if y == "True":
                     python_examples_sorted.append(x)
             python_examples_sorted.sort()
             examples_sorted.extend(python_examples_sorted)
@@ -1334,9 +1414,9 @@
     # The file is created outside the directory that gets automatically deleted.
     #
     xml_results_file = os.path.join(TMP_OUTPUT_DIR, f"{date_and_time}-results.xml")
-    with open(xml_results_file, 'w', encoding='utf-8') as f:
+    with open(xml_results_file, "w", encoding="utf-8") as f:
         f.write('<?xml version="1.0"?>\n')
-        f.write('<Results>\n')
+        f.write("<Results>\n")
 
     #
     # We need to figure out what test suites to execute.  We are either given one
@@ -1375,20 +1455,30 @@
         suites_found = fnmatch.filter(suites.split("\n"), args.suite)
 
         if not suites_found:
-            print('The test suite was not run because an unknown test suite name was requested.', file=sys.stderr)
+            print(
+                "The test suite was not run because an unknown test suite name was requested.",
+                file=sys.stderr,
+            )
             sys.exit(2)
         elif len(suites_found) == 1:
             single_suite = True
 
-        suites = '\n'.join(suites_found)
+        suites = "\n".join(suites_found)
 
     elif ENABLE_TESTS and len(args.example) == 0 and len(args.pyexample) == 0:
         if len(args.constrain):
-            path_cmd = os.path.join("utils", test_runner_name + " --print-test-name-list --test-type=%s" % args.constrain)
-            (rc, suites, standard_err, et) = run_job_synchronously(path_cmd, os.getcwd(), False, False)
+            path_cmd = os.path.join(
+                "utils",
+                test_runner_name + " --print-test-name-list --test-type=%s" % args.constrain,
+            )
+            (rc, suites, standard_err, et) = run_job_synchronously(
+                path_cmd, os.getcwd(), False, False
+            )
         else:
             path_cmd = os.path.join("utils", test_runner_name + " --print-test-name-list")
-            (rc, suites, standard_err, et) = run_job_synchronously(path_cmd, os.getcwd(), False, False)
+            (rc, suites, standard_err, et) = run_job_synchronously(
+                path_cmd, os.getcwd(), False, False
+            )
     else:
         suites = ""
 
@@ -1402,21 +1492,24 @@
     #
     if isinstance(suites, bytes):
         suites = suites.decode()
-    suite_list = suites.split('\n')
+    suite_list = suites.split("\n")
 
     #
     # Performance tests should only be run when they are requested,
     # i.e. they are not run by default in test.py.
     # If a specific suite was requested we run it, even if
     # it is a performance test.
-    if not single_suite and args.constrain != 'performance':
-
+    if not single_suite and args.constrain != "performance":
         # Get a list of all of the performance tests.
-        path_cmd = os.path.join("utils", test_runner_name + " --print-test-name-list --test-type=%s" % "performance")
-        (rc, performance_tests, standard_err, et) = run_job_synchronously(path_cmd, os.getcwd(), False, False)
+        path_cmd = os.path.join(
+            "utils", test_runner_name + " --print-test-name-list --test-type=%s" % "performance"
+        )
+        (rc, performance_tests, standard_err, et) = run_job_synchronously(
+            path_cmd, os.getcwd(), False, False
+        )
         if isinstance(performance_tests, bytes):
             performance_tests = performance_tests.decode()
-        performance_test_list = performance_tests.split('\n')
+        performance_test_list = performance_tests.split("\n")
 
         # Remove any performance tests from the suites list.
         for performance_test in performance_test_list:
@@ -1440,10 +1533,12 @@
     processors = 1
 
     if sys.platform != "win32":
-        if 'SC_NPROCESSORS_ONLN' in os.sysconf_names:
-            processors = os.sysconf('SC_NPROCESSORS_ONLN')
+        if "SC_NPROCESSORS_ONLN" in os.sysconf_names:
+            processors = os.sysconf("SC_NPROCESSORS_ONLN")
         else:
-            proc = subprocess.Popen("sysctl -n hw.ncpu", shell=True, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
+            proc = subprocess.Popen(
+                "sysctl -n hw.ncpu", shell=True, stdout=subprocess.PIPE, stderr=subprocess.PIPE
+            )
             stdout_results, stderr_results = proc.communicate()
             stdout_results = stdout_results.decode()
             stderr_results = stderr_results.decode()
@@ -1454,10 +1549,10 @@
 
     if args.process_limit:
         if processors < args.process_limit:
-            print('Using all %s processors' % processors)
+            print("Using all %s processors" % processors)
         else:
             processors = args.process_limit
-            print('Limiting to %s worker processes' % processors)
+            print("Limiting to %s worker processes" % processors)
 
     #
     # Now, spin up one thread per processor which will eventually mean one test
@@ -1506,7 +1601,9 @@
             else:
                 fullness = " --fullness=QUICK"
 
-            path_cmd = os.path.join("utils", test_runner_name + " --test-name=%s%s%s" % (test, multiple, fullness))
+            path_cmd = os.path.join(
+                "utils", test_runner_name + " --test-name=%s%s%s" % (test, multiple, fullness)
+            )
 
             job.set_shell_command(path_cmd)
 
@@ -1562,9 +1659,9 @@
             if ENABLE_EXAMPLES:
                 for name, test, do_run, do_valgrind_run in example_tests:
                     # Remove any arguments and directory names from test.
-                    test_name = test.split(' ', 1)[0]
+                    test_name = test.split(" ", 1)[0]
                     test_name = os.path.basename(test_name)
-                    test_name = test_name[:-4] if sys.platform == 'win32' else test_name
+                    test_name = test_name[:-4] if sys.platform == "win32" else test_name
 
                     # Don't try to run this example if it isn't runnable.
                     if test_name in ns3_runnable_programs_dictionary:
@@ -1584,7 +1681,10 @@
                                 job.set_is_skip(True)
                                 job.set_skip_reason("skip in valgrind runs")
 
-                            if args.rerun_failed and name in previously_run_tests_to_skip["example"]:
+                            if (
+                                args.rerun_failed
+                                and name in previously_run_tests_to_skip["example"]
+                            ):
                                 job.is_skip = True
                                 job.set_skip_reason("didn't fail in the previous run")
 
@@ -1657,7 +1757,7 @@
         if len(args.constrain) == 0 or args.constrain == "pyexample":
             for test, do_run in python_tests:
                 # Remove any arguments and directory names from test.
-                test_name = test.split(' ', 1)[0]
+                test_name = test.split(" ", 1)[0]
                 test_name = os.path.basename(test_name)
 
                 # Don't try to run this example if it isn't runnable.
@@ -1705,6 +1805,7 @@
         # Find the full relative path to file if only a partial path has been given.
         if not os.path.exists(args.pyexample):
             import glob
+
             files = glob.glob("./**/%s" % args.pyexample, recursive=True)
             if files:
                 args.pyexample = files[0]
@@ -1802,7 +1903,7 @@
                 status = "CRASH"
                 status_print = colors.PINK + status + colors.NORMAL
 
-        print("[%d/%d]" % (i, total_tests), end=' ')
+        print("[%d/%d]" % (i, total_tests), end=" ")
         if args.duration or args.constrain == "performance":
             print("%s (%.3f): %s %s" % (status_print, job.elapsed_time, kind, job.display_name))
         else:
@@ -1818,24 +1919,24 @@
             # XXX We could add some timing information to the examples, i.e. run
             # them through time and print the results here.
             #
-            with open(xml_results_file, 'a', encoding='utf-8') as f:
-                f.write('<Example>\n')
+            with open(xml_results_file, "a", encoding="utf-8") as f:
+                f.write("<Example>\n")
                 example_name = "  <Name>%s</Name>\n" % job.display_name
                 f.write(example_name)
 
                 if status == "PASS":
-                    f.write('  <Result>PASS</Result>\n')
+                    f.write("  <Result>PASS</Result>\n")
                 elif status == "FAIL":
-                    f.write('  <Result>FAIL</Result>\n')
+                    f.write("  <Result>FAIL</Result>\n")
                 elif status == "VALGR":
-                    f.write('  <Result>VALGR</Result>\n')
+                    f.write("  <Result>VALGR</Result>\n")
                 elif status == "SKIP":
-                    f.write('  <Result>SKIP</Result>\n')
+                    f.write("  <Result>SKIP</Result>\n")
                 else:
-                    f.write('  <Result>CRASH</Result>\n')
+                    f.write("  <Result>CRASH</Result>\n")
 
                 f.write('  <Time real="%.3f"/>\n' % job.elapsed_time)
-                f.write('</Example>\n')
+                f.write("</Example>\n")
 
         else:
             #
@@ -1883,16 +1984,18 @@
             # followed by a VALGR failing test suite of the same name.
             #
             if job.is_skip:
-                with open(xml_results_file, 'a', encoding='utf-8') as f:
+                with open(xml_results_file, "a", encoding="utf-8") as f:
                     f.write("<Test>\n")
                     f.write("  <Name>%s</Name>\n" % job.display_name)
-                    f.write('  <Result>SKIP</Result>\n')
+                    f.write("  <Result>SKIP</Result>\n")
                     f.write("  <Reason>%s</Reason>\n" % job.skip_reason)
                     f.write("</Test>\n")
             else:
                 failed_jobs.append(job)
                 if job.returncode == 0 or job.returncode == 1 or job.returncode == 2:
-                    with open(xml_results_file, 'a', encoding='utf-8') as f_to, open(job.tmp_file_name, encoding='utf-8') as f_from:
+                    with open(xml_results_file, "a", encoding="utf-8") as f_to, open(
+                        job.tmp_file_name, encoding="utf-8"
+                    ) as f_from:
                         contents = f_from.read()
                         if status == "VALGR":
                             pre = contents.find("<Result>") + len("<Result>")
@@ -1903,10 +2006,10 @@
                         if et.find("Result").text in ["PASS", "SKIP"]:
                             failed_jobs.pop()
                 else:
-                    with open(xml_results_file, 'a', encoding='utf-8') as f:
+                    with open(xml_results_file, "a", encoding="utf-8") as f:
                         f.write("<Test>\n")
                         f.write("  <Name>%s</Name>\n" % job.display_name)
-                        f.write('  <Result>CRASH</Result>\n')
+                        f.write("  <Result>CRASH</Result>\n")
                         f.write("</Test>\n")
 
     #
@@ -1923,39 +2026,55 @@
     # individual pieces.  So, we need to finish off and close out the XML
     # document
     #
-    with open(xml_results_file, 'a', encoding='utf-8') as f:
-        f.write('</Results>\n')
+    with open(xml_results_file, "a", encoding="utf-8") as f:
+        f.write("</Results>\n")
 
     #
     # Print a quick summary of events
     #
-    print("%d of %d tests passed (%d passed, %d skipped, %d failed, %d crashed, %d valgrind errors)" % (passed_tests,
-        total_tests, passed_tests, skipped_tests, failed_tests, crashed_tests, valgrind_errors))
+    print(
+        "%d of %d tests passed (%d passed, %d skipped, %d failed, %d crashed, %d valgrind errors)"
+        % (
+            passed_tests,
+            total_tests,
+            passed_tests,
+            skipped_tests,
+            failed_tests,
+            crashed_tests,
+            valgrind_errors,
+        )
+    )
     #
     # Repeat summary of skipped, failed, crashed, valgrind events
     #
     if skipped_testnames:
         skipped_testnames.sort()
-        print('List of SKIPped tests:\n    %s' % '\n    '.join(map(str, skipped_testnames)))
+        print("List of SKIPped tests:\n    %s" % "\n    ".join(map(str, skipped_testnames)))
     if failed_testnames:
         failed_testnames.sort()
-        print('List of FAILed tests:\n    %s' % '\n    '.join(map(str, failed_testnames)))
+        print("List of FAILed tests:\n    %s" % "\n    ".join(map(str, failed_testnames)))
     if crashed_testnames:
         crashed_testnames.sort()
-        print('List of CRASHed tests:\n    %s' % '\n    '.join(map(str, crashed_testnames)))
+        print("List of CRASHed tests:\n    %s" % "\n    ".join(map(str, crashed_testnames)))
     if valgrind_testnames:
         valgrind_testnames.sort()
-        print('List of VALGR failures:\n    %s' % '\n    '.join(map(str, valgrind_testnames)))
+        print("List of VALGR failures:\n    %s" % "\n    ".join(map(str, valgrind_testnames)))
 
     if failed_jobs and args.verbose_failed:
         for job in failed_jobs:
             if job.standard_out or job.standard_err:
-                job_type = 'example' if (job.is_example or job.is_pyexample) else 'test suite'
-                print(f"===================== Begin of {job_type} '{job.display_name}' stdout =====================")
+                job_type = "example" if (job.is_example or job.is_pyexample) else "test suite"
+                print(
+                    f"===================== Begin of {job_type} '{job.display_name}' stdout ====================="
+                )
                 print(job.standard_out)
-                print(f"===================== Begin of {job_type} '{job.display_name}' stderr =====================")
+                print(
+                    f"===================== Begin of {job_type} '{job.display_name}' stderr ====================="
+                )
                 print(job.standard_err)
-                print(f"===================== End of {job_type} '{job.display_name}' ==============================")
+                print(
+                    f"===================== End of {job_type} '{job.display_name}' =============================="
+                )
     #
     # The last things to do are to translate the XML results file to "human-
     # readable form" if the user asked for it (or make an XML file somewhere)
@@ -1970,10 +2089,10 @@
         translate_to_text(xml_results_file, args.text)
 
     if len(args.xml):
-        xml_file = args.xml + ('.xml' if ".xml" not in args.xml else '')
-        print('Writing results to xml file %s...' % xml_file, end='')
+        xml_file = args.xml + (".xml" if ".xml" not in args.xml else "")
+        print("Writing results to xml file %s..." % xml_file, end="")
         shutil.copyfile(xml_results_file, xml_file)
-        print('done.')
+        print("done.")
 
     #
     # Let the user know if they need to turn on tests or examples.
@@ -1981,11 +2100,11 @@
     if not ENABLE_TESTS or not ENABLE_EXAMPLES:
         print()
         if not ENABLE_TESTS:
-            print('***  Note: ns-3 tests are currently disabled. Enable them by adding')
+            print("***  Note: ns-3 tests are currently disabled. Enable them by adding")
             print('***  "--enable-tests" to ./ns3 configure or modifying your .ns3rc file.')
             print()
         if not ENABLE_EXAMPLES:
-            print('***  Note: ns-3 examples are currently disabled. Enable them by adding')
+            print("***  Note: ns-3 examples are currently disabled. Enable them by adding")
             print('***  "--enable-examples" to ./ns3 configure or modifying your .ns3rc file.')
             print()
 
@@ -1995,8 +2114,8 @@
     #
     if args.valgrind and not VALGRIND_FOUND:
         print()
-        print('***  Note: you are trying to use valgrind, but valgrind could not be found')
-        print('***  on your machine.  All tests and examples will crash or be skipped.')
+        print("***  Note: you are trying to use valgrind, but valgrind could not be found")
+        print("***  on your machine.  All tests and examples will crash or be skipped.")
         print()
 
     #
